Package org.apache.sysds.hops

# Class BinaryOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.MultiThreadedHop
org.apache.sysds.hops.BinaryOp

All Implemented Interfaces:
  `ParseInfo`

public class BinaryOp extends MultiThreadedHop
Binary (cell operations): aij + bij Properties: Symbol: *, -, +, ... 2 Operands Semantic: align indices (sort), then perform operation

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static enum`
`BinaryOp.AppendMethod`
`static enum`
`BinaryOp.MMBinaryMethod`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`APPEND_MEM_MULTIPLIER`
`static BinaryOp.AppendMethod`
`FORCED_APPEND_METHOD`
`static BinaryOp.MMBinaryMethod`
`FORCED_BINARY_METHOD`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`BinaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp2 o, Hop inp1, Hop inp2)`
`BinaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp2 o, Hop inp1, Hop inp2, boolean outer)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`Lop`
`constructLops()`
`static Lop`
`constructSPAppendLop(Hop left, Hop right, Types.DataType dt, Types.ValueType vt, boolean cbind, Hop current)`
`static double`
`footprintInMapper(long m1_dim1, long m1_dim2, long m2_dim1, long m2_dim2, long m1_rpb, long m1_cpb)`
Estimates the memory footprint of MapMult operation depending on which input is put into distributed cache.
`Types.OpOp2`
`getComplementPPredOperation()`
`Types.OpOp2`
`getOp()`
`String`
`getOpString()`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isInplace()`
`boolean`
`isMultiThreadedOpType()`
`boolean`
`isOuter()`
`boolean`
`isPPredOperation()`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.
`static boolean`
`requiresReplication(Hop left, Hop right)`
`void`
`setOp(Types.OpOp2 iop)`
`void`
`setOuterVectorOperation(boolean flag)`
`boolean`
`supportsMatrixScalarOperations()`

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### APPEND_MEM_MULTIPLIER

public static final double APPEND_MEM_MULTIPLIER

See Also:
  - Constant Field Values

### FORCED_APPEND_METHOD

public static BinaryOp.AppendMethod FORCED_APPEND_METHOD

### FORCED_BINARY_METHOD

public static BinaryOp.MMBinaryMethod FORCED_BINARY_METHOD

## Constructor Details

### BinaryOp

public BinaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp2 o, Hop inp1, Hop inp2)

### BinaryOp

public BinaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp2 o, Hop inp1, Hop inp2, boolean outer)

## Method Details

### getOp

public Types.OpOp2 getOp()

### setOp

public void setOp(Types.OpOp2 iop)

### setOuterVectorOperation

public void setOuterVectorOperation(boolean flag)

### isOuter

public boolean isOuter()

### isInplace

public boolean isInplace()

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### isMultiThreadedOpType

public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### constructSPAppendLop

public static Lop constructSPAppendLop(Hop left, Hop right, Types.DataType dt, Types.ValueType vt, boolean cbind, Hop current)

### footprintInMapper

public static double footprintInMapper(long m1_dim1, long m1_dim2, long m2_dim1, long m2_dim2, long m1_rpb, long m1_cpb)
Estimates the memory footprint of MapMult operation depending on which input is put into distributed cache. This function is called by `optFindAppendMethod()` to decide the execution strategy, as well as by piggybacking to decide the number of Map-side instructions to put into a single GMR job.

Parameters:
  `m1_dim1` - ?
  `m1_dim2` - ?
  `m2_dim1` - ?
  `m2_dim2` - ?
  `m1_rpb` - ?
  `m1_cpb` - ?
Returns:
  memory footprint estimate

### requiresReplication

public static boolean requiresReplication(Hop left, Hop right)

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`

### supportsMatrixScalarOperations

public boolean supportsMatrixScalarOperations()

### isPPredOperation

public boolean isPPredOperation()

### getComplementPPredOperation

public Types.OpOp2 getComplementPPredOperation()